# WH40k Character Manager v3.2 by Grego


# Table of contents:

1. What is WH40k Character Manager?
2. Application overview
3. Detailed application functionality
4. FAQ
5. Actualization history
6. The future of the project
7. Contact




# 1. What is WH40k Character Manager?

	WH40k Character Manager is an unofficial application that aims to help character creation and managing for the following RPG systems:
	- Dark Heresy 2ed.,
	- Only War.,
	- Rogue Trader convertion (based on https://docs.google.com/document/d/1M2hzwyXYNXrkFNYrazSDwbiF_O-NlETOjm9FGLyhA9A).
	

# 2. Application overview

	The application does NOT need internet connection during day-to-day usage. All character data is stored locally, in a file located in the same 
	folder as the executable file.
	This application contains a lot of condensed information regarding character creation and managing, but it doesn't exclude a neccessity for
	looking up some information in DH 2ed. or OW rulebooks.
	It is possible to synchronize characters' data with website server: https://wh40kchm.waw.pl. Doing so enables:
	- character edition in web browser,
	- easy data transfer to other computers,
	- using website server to keep backups of data.
	In order to use the website, it is necessary to create an account (see 3.2.3.)
	For the purpose of application update, it is highly recommended to use built-in update mechanism, which should properly move existing character data
	to a new version of the application.
	The application allows to generate a filled PDF character sheet. The only supported PDF files are those originally stored in the application folder.
	However, it is possible to make a copy of such a PDF file, fill it with data that won't be overwritten by the application (i.e. character's items)
	and choose that copy in the application as a base file to fill in.
	Dear player - please remember to use this application in consultation with your GM! The manager allows for many choices that can drastically change
	your character (elite advances, mutations etc.) and should be accepted by the GM.
	

# 3. Detailed application functionality

	## 3.1. "File" Menu
	"File" Menu has the following options:
	a) Open Character - opens an already created character.
	b) New Character - creates new character.
	c) Save Character - saves currently opened character.
	d) Delete Character - deletes currently opened character.
	e) Generate PDF Sheet - generates a character sheet in a form of a filled PDF file.
	f) Talent Overview - opens a window in which you can explore talent sets available in the manager.
	g) Creation Helpers - opens a window with creation helper panels.
	h) Settings - allows for application's settings edition.
	
	### 3.1.1. Open Character
	When this option is chosen, the manager shows a list of existing characters. After choosing one of them, the manager shows (in the main window) several
	tab pages dedicated to different character data:
	- Non-Modifiable: Contains basic character's information that can't be modified directly (XP spent, Aptitudes, chosen Homeworld etc.)
	- XP-independent: Contains XP-independent editable character statistics (Corruption Points, Mental Disorders etc.)
	- Elite Advances: Contains Elite Advances available for the character.
	- Characteristics: Contains a table for characteristics management.
	- Skills: Contains a paged table for skills management, with sorting and filtering.
	- Talents: Contains a paged table for talents management, with sorting and filtering.
	- Special Advances: Contains a paged table for psychic powers and orders management, with sorting and filtering.
	- Plans: Contains a paged table for plans management (created in "Characteristics", "Skills", "Talents" & "Special Advances" panels).
	- Notes: Contains a textbox for personal notes.
	- Changes History: Contains an automatically updated history of character changes.
	Rows in "Characteristics", "Skills", "Talents" & "Special Advances" panels have different color depending on the amount of matching Aptitudes 
	the character has:
	- Green: 2 Aptitudes.
	- Yellow: 1 Aptitude.
	- Red: 0 Aptitudes.
	
	### 3.1.2. New Character
	When this option is chosen, the manager will show the list of available character creation types.
	After choosing one of them, the name of a character must be provided.
	After providing the name, one must make further choices that are characteristic for the chosen creation type.
	Through the whole character creation process, on the right side of the window, a summary of the choices made so far is presented. 
	In the case of number values i.e. wounds or characteristic values, it is possible to either generate random values or provide them manually.
	After making it through the steps described above, it is possible that the resulting Aptitude set has duplicates. In such case, the manager
	will give the option of choosing replacement Aptitudes (in accordance with the standard RPG system rules).
	After the character creation process is finished, the manager will save locally the character data and show (in the main window) several
	tab pages dedicated to different character data (see 3.1.1.)
	
	### 3.1.3. Save Character
	When a character is opened in the manager's main window, choosing this option will save locally the character data. Most of the provided
	changes can be reverted by unchecking them in the main window. The most common exceptions to this rule are Elite Advances - after confirming
	an elite advance choice, there's no going back; all choices made before an elite advance choice will also become irreversible.
	
	### 3.1.4. Delete Character
	When a character is opened in the manager's main window, choosing this option will delete character data stored locally.
	This operation is irreversible.
	
	### 3.1.5. Generate PDF Sheet
	When a character is opened in the manager's main window, choosing this option will open a window for character sheet generation in the form
	of a PDF file. In that window, the following customization options will be available:
	a) Fill changeable data - fills the character sheet with data that is likely to change in the future, i.e. characteristic values. Default is true.
	b) Use default PDF template / Choose PDF template - gives the option of choosing a PDF file filled by the manager. CAUTION - this option's only
	purpose is to apply changes to an already pre-filled character sheet (i.e. with items). The main source PDF file must be:
	- In the case of Only War: Only_War_PC_Sheet.pdf file.
	- In the case of Dark Heresy 2ed.: Dark_Heresy_PC_Sheet.pdf file.
	The files mentioned above are located in the manager's folder and must not be deleted.
	c) Order talents (By acquire time / By name) - gives the option of choosing talents sorting.
	
	### 3.1.6. Talent Overview
	When this option is chosen, the manager will show the list of available talent sets. After choosing one of them, the manager will show
	a separate window with a paged table for talents browsing, with sorting and filtering.
	The window mentioned above keeps the manager's main window responsive and it can be used during character creation.
	
	### 3.1.7. Creation Helpers
	When this option is chosen, it will open a window with creation helper panels. At the moment, there are available two of them:
	- Aptitudes: It allows to filter out those character creation option sets that provide chosen Aptitudes.
	- Tags: It allows to find character creation options based on provided tags - great for those that approach character creation more "storywise".
	The window mentioned above keeps the manager's main window responsive and it can be used during character creation.

	### 3.1.8. Settings
	When this option is chosen, the manager will show its settings, which are:
	- RowsPerPage - a maximum number of rows being displayed on a single page of the tables with skills, talents, plans, psychic powers and orders.
	- Username - name of the user used in data synchronization with remote server. A user account has to be created beforehand.
	For more about data synchronization with remote server, see 3.2.
	- Password - password for the user used in data synchronization with remote server. A user account has to be created beforehand.
	For more about data synchronization with remote server, see 3.2.
	- RememberLastCharacter - when this setting is checked, the manager will be remembering opened character when being closed, so it can automatically
	open it during next startup.
	- MasterMode - when this setting is checked, the manager goes into state in which characters can be edited in a wider scope, without spending XP.
	The main purpose of this setting is to give the option of providing changes that doesn't result from standard character progression (i.e. GM's demand).
	After returning to the standard mode, all changes made during AND before MasterMode will become irreversible in standard mode.
	- MainScreenHeight - screen height of the manager's main screen (in pixels).

	## 3.2. "Remote" Menu
	"Remote" Menu has the following options:
	a) Upload - allows to upload local character changes to remote server.
	b) Download - allows to download character changes from remote server.
	b) Create account - creates a new user account on the remote server and saves locally its credentials.
	
	### 3.2.1. Upload
	In order for this option to work, an internet connection is necessary, as well as providing Username and Password in application settings (see 3.1.8.)
	When this option is chosen, the manager will show a window for choosing upload configuration. The following options are available:
	 - Update locally changed characters - sends and saves changes for characters present both locally and on remote server.
	 - Add characters created locally - adds characters to remote server that were created locally.
	 - Delete characters removed locally - deletes characters on remote server that were deleted locally.
	After confirming the options with the "Perform" button, adequate operations will be performed on a remote server. They are irreversible;
	 
	### 3.2.2. Download
	In order for this option to work, an internet connection is necessary, as well as providing Username and Password in application settings (see 3.1.8.)
	When this option is chosen, the manager will show a window for choosing download configuration. The following options are available:
	- Update remotely changed characters - downloads and saves changes for characters present both locally and on remote server.
	- Add characters created remotely - adds locally missing characters from remote server.
	- Delete characters removed remotely - deletes locally characters missing from remote server.
	After confirming the options with the "Perform" button, adequate operations will be performed on local data. They are irreversible;
	
	### 3.2.3. Create account
	In order for this option to work, an internet connection is necessary.
	When this option is chosen, the manager will show a window for providing data for new user account.
	After providing and confirming the data, the account will be created on a remote server, and its credentials will be automatically saved in local
	application settings - there is no need to provide that data again.
	When the above operations are done:
	- manager is ready to use "Upload" and "Download" options for the newly created account,
	- it's possible to log in on https://wh40kchm.waw.pl onto the newly created account,
	- (after using "Upload" option beforehand) it's possible to edit character data in web browser.
	
	## 3.3. "Help" Menu
	"Help" Menu has the following options:
	a) Check for update - checks if an update for the manager exists (and, if it does, downloads it)
	b) About application - shows basic information about the manager.
	
	### 3.3.1. Check for update
	In order to use this option properly, the internet connection must be provided.
	When this option is chosen, the manager will check if an update is available, and show the check results. If an update is available, the manager
	will give the option of downloading it.
	After acknowledging the choice, the manager will download the update and give the option of installing it.
	After acknowledging the choice again, the manager will reinstall and reopen itself.


# 4. FAQ

	## Who are you?
	
	I'm Grego, a man with a passion to being a GM. For many years I've been GM'ing campaigns in various WH40k FFG systems and conversions based on them.
	At this moment I can be considered as a very experienced GM in the area of Dark Heresy 2ed. oraz Rogue Trader, with significant experience in Only War
	and familiar with a Deathwatch conversion to DH 2ed. mechanics. My second hobby is software development, which is also what I do
	for a living.
	
	## Does the manager include all the character creation and progression mechanics in the Dark Heresy 2ed. system?
	
	For the time being, the mamager should include all the mentioned mechanics in the Dark Heresy 2ed. system, with the exception of Malignancies
	and Homeworlds from supplemental rulebooks that are named planets (i.e. Kalto from Enemies Within).
	
	## Does the manager include all the character creation and progression mechanics in the Only War system?
	
	For the time being, the mamager should include all the mentioned mechanics in the Only War system, with the exception of Malignancies
	and Veteran Talents.
	
	## What are your reasons for designing, developing and extending this manager the way you do?
	
	I'm trying to meet the needs and take into account the comments of various entities, whose priority (for me) is as follows:
	1. Me.
	2. My players.
	3. Polish WH40k community.
	4. Rest of the world.
	
	## Why didn't you include Malignancies? Will you add them in the nearest future?

	I didn't include them because I don't use them in this form in my campaigns. I don't have plans for adding them.
	Malignancies can be simulated by applying appropriate operations when in MasterMode (see 3.1.8).
	
	## [DH 2ed.] Why didn't you include named planets as Homeworlds? Will you add them in the nearest future?

	I didn't include them because my campaigns take place in my custom sector. Adding them to the manager isn't important for me, but it is possible
	that I will add them on the occasion, if the community will be interested in it.
	
	## [OW] Why didn't you include Veteran Talents? Will you add them in the nearest future?

	I didn't include them because I thought that adding them would do more harm than good (mainly because of the necessity for meeting
	the Battlefield Requirement). Adding them to the manager isn't important for me, but it is possible	that I will add them on the occasion,
	if the community will be interested in it.
	
	## [OW] Character creation lacks Special Equipment Doctrines.
	
	That's correct, I intentionally omitted that step, because it affects only character's equipment, which isn't handled by the manager.
	
	## [OW] Why Support Speciality characters start with 300 XP spent?
	
	To equalize them with the starting 600 XP of other characters, for the purposes of checking threshold exceeding for possible speciality change.
	
	## I've made a mistake during character creation. Do I have to go through the whole creation process again?
	
	Yes.
	
	## Can I delete a specialist skill/talent row that I've created by/with mistake?
	
	No. You can leave it unchecked, but the row will remain with you forever as a sign of your failure.
	
	## Will you add item managing?
	
	Yes, but not in the nearest future.
	
	## What guarantee do I have that you implemented everything properly according to the rulebooks?
	
	I cannot give any guarantee. I can only vouch for my experience in WH40k RPG's from FFG and in software development, but of course it doesn't
	prove anything. If you will find an error in the manager - tell me of it (see 7.) and I'll try to fix it!
	
	## I have comments for the manager's graphical user interface...
	
	You can send them to me. To be honest, however, the chances that I will adress them are relatively low at best.
	The reasons for it are:
	a) I've got my own priorities when working on the manager.
	b) I'm not a professional GUI developer and never will be.
	c) I'm a big fan of the Engineer's First Principle: "If it works - don't touch it. The best is the enemy of the good."
	
	## Does the character manager website provide the same functionalty as this desktop epplication?
	
	No. For now, the website allows only for managing an already created character. Other functions are unavailable, especially:
	- Creating a new character. In order to create a new character & edit it in web browser, you have to create character in desktop application
	and then upload it to the remote server (see 3.2.1.)
	- MasterMode state.
	- Generating character sheet PDF.
	Some of those functions are considered to be added to the website at some point. When exactly? Only the Emperor knows.
	
	## Are you gonna add character creation/managing for other FFG systems?
	
	No. I'm interested only in the systems with Aptitudes.
	
	## Are you gonna add character creation/managing for some popular convertion/homebrews for FFG systems?
	
	The problem is, it is difficult to clearly define if a given convertion/homebrew is popular. I do use some of them myself and, in a manager version
	available to my players only, I've included character creation for them, but it also includes my homerules.
	If there is enough interest in a particular conversion/homebrew among the community, I'll consider adding a character creation for it - just like I made with "RT2".
	
	## Are you gonna add character creation/managing for Wrath & Glory?
	
	No. I'm interested only in FFG systems. There are other brilliant W&G tools being developed - go check them out!
	
	## Is your project available on Github, Bitbucket etc.?
	
	No. It's a private project on Bitbucket and it won't change. The reasons for it I'll also keep private.
	
	## Is it possible to contribute to your project as a software developer?
	
	I don't plan to share the manager's development in the current form. Some of the reasons for it are:
	a) I want to keep the manager's project private.
	b) There's enough contact with people for me when in work and on RPG sessions, I don't crave for more.
	c) I'm a big fan of relying on myself.
	

# 5. Actualization history

	Version 1.0:
		First ever published version of the application.
	Version 1.1:
		Fixed actualization mechanism.
	Version 1.2:
		Improved the application's performance.
	Version 1.3:
		Improved the application's performance.
	Version 1.4:
		Improved the application's performance.
	Version 1.5:
		- Added the possibility to add notes to character progression plans.
		- Added the possibility to filter bought/unbought skills/talents/psychic powers.
		- Added timestamp to generated PDF sheet's name.
		- Improved design of the character creation panels.
	Version 1.6:
		Added a possibility to change the number of rows displayed on a single page of a table.
	Version 1.7:
		Added elite advance "Sister of Battle".
	Version 1.8:
		- Extended skills/talents/psychic powers filtering.
		- Added informing the user about connection problems during application update.
	Version 1.9:
		- Added a button for resetting filters.
		- Fixed the filtering of specialist skills and talents.
	Version 1.10:
		Improved the application's performance.
	Version 1.11:
		Added character creation & management for Only War (without Advanced Specialities).
	Version 1.12:
		Fixed checking requirements for talents with specialization.
	Version 1.13:
		- Applied refactorization of character data save/load mechanism .
		- Added Advanced Specialities mechanism to character management in Only War.
		- Improved the application's GUI performance.
	Version 1.14:
		Improved the application's performance.
	Version 1.15:
		- Fixed loading Only War character data.
	Version 1.16:
		- Added the option of choosing a PDF sheet file to be filled by the manager.
		- Added the option of not filling the character sheet with data that is likely to change in the future.
		- Added the option of choosing talent sorting on generated PDF sheet.
		- Added MasterMode.
		- Fixed handling plans for talents that can be bought multiple times.
		- Fixed some small GUI issues.
	Version 1.17:
		- Added Talent Overwiev option.
		- Decreased row height in tables with character data.
		- Enforced changing main window's height through application settings.
	Version 1.18:
		- Added Notes tab page to character management.
		- Added sending email to the manager's author when an unexpected exception occurs.
		- Fixed psychic power filters.
		- Fixed bug regarding saving character after buying an elite advance.
		- Fixed bug regarding displaying psychic powers during Only War character creation.
	Version 1.19:
		- Fixed bug regarding handling the Astropath elite advance.
	Version 1.20:
		- Added autocheck for unsaved changes when closing a character/application. 
		- Added (as talents) special orders from "Shield of Humanity" to Only War character management.
	Version 1.21:
		- Added the option of remembering last opened character.
		- Improved database structure.
		- Fixed the autocheck for unsaved changes.
		- Fixed adjusting window content to its size.
		- Applied refactorization of the code responsible for database communication & PDF generation.
	Version 1.22:
		- Fixed the autocheck for unsaved changes.
	Version 1.23:
		- Improved the application's performance.
		- Extended polish README file.
		- Added english README file.
	Version 1.24:
		Fixed checking requirements for talents.
	Version 2.0:
		- Added a possiibility to synchronize characters' data with https://wh40kchm.waw.pl website.
		- Added automatically updated history of character changes, available to check in a separate panel during character edition.
		- Added creation helpers.
		- Greatly improved the application's performance.
		- Fixed the autocheck for unsaved changes.
		- Fixed some minor bugs in character creation.
		- Fixed some minor bugs in plan management.
		- Fixed displaying various GUI elements.
	Version 2.1:
		- Improved the application's performance in the area of checking talent requirements (which is done automatically basically after each character change).
		- Done some refactorization of the application's code, which will hopefully make it easier to improve & maintain.
	Version 2.2:
		- Added possibility to change Fate Points amount in Master Mode.
		- Improved the application's performance of managing plans.
		- Improved the application's performance in the area of sorting and applying filters.
		- Fixed an issue with performing recently added plans.
		- Fixed generating default values of characteristics during character creation.
		- Done some refactorization of the application's code, which will hopefully make it easier to improve & maintain.
	Version 2.3:
		- Added two "RT2" homebrew character creation options.
		- Improved the application's performance in managing psychic powers / orders ("special advances").
		- Removed unnecessary displaying info about psychic power requirements in Master Mode.
		- Fixed an issue with abandoning character creation.
		- Fixed some typos.
		- Done some refactorization of the application's code, which will hopefully make it easier to improve & maintain.
	Version 2.4:
		- Improved the application's performance in managing skills.
		- Fixed an issue with the lack of owned XP verification for buying characteristic upgrades.
		- Fixed a rare bug with creating Only War character.
		- Fixed a bug with enabling buttons for adding plans.
		- Done some refactorization of the application's code, which will hopefully make it easier to improve & maintain.
	Version 2.5:
		- Fixed an issue with loading character with plans for skills.
	Version 2.6:
		- Improved the performance of the application's startup nad processing of choice of most of the options from the application's menu.
		- Improved the visual aspect of creating the tab pages in the main windows when e.g. loading chosen character.
		- Improved the graphical interface of settings management.
		- Disabled the options for saving a character & generating PDF when there is no character currently opened.
		- Fixed the invalid possibility to choose again a mutation or malignancy a character already has.
		- Fixed disabling the main window during new character creation.
		- Fixed showing chosen creation type in the summary pannel.
		- Done some refactorization of the application's code, which will hopefully make it easier to improve & maintain.
	Version 2.7:
		- Fixed applying all the effects of enabling/disabling Master Mode when application is running.
		- Fixed some issues with sending e-mail to the app's author when an unexpected error occurs.
		- Done some refactorization of the application's code, which will hopefully make it easier to improve & maintain.
	Version 2.8:
		- Fixed a bug when showing character changes history for a character that bought some special advances (psychic powers or orders).
		- Fixed a bug when updating the application.
		- Fixed a bug with sending e-mail to the app's author when an unexpected error occurs.
	Version 2.9:
		- Unified some aspects of graphical interface for character creation.
		- Improved refreshing content in character creation panels.
		- Fixed a bug with unbuying highest skill rank.
		- Done some refactorization of the application's code, which will hopefully make it easier to improve & maintain.
	Version 3.0:
		- Improved the application's performance.
		- Improved handling too many speicalist skills for .pdf character sheet.
		- Fixed a bug with wrong state of the application after sending character data to remote server.
		- Removed unnecessary info popups when sending character data to remote server.
		- Done some refactorization of the application's code, which will hopefully make it easier to improve & maintain.
	Version 3.1:
		- Made opened character changes history panel refresh each time the changes are saved.
		- Increased maximum length of text lines the application can save in talents section on .pdf character sheet.
		- Made some small changes to settings management.
		- Fixed errors in the description of some talents.
		- Done some refactorization of the application's code, which will hopefully make it easier to improve & maintain.
	Version 3.2:
		- Added veryfing disorders being provided during character creation.
		- Fixed a couple of minor GUI issues.
		- Done some refactorization of the application's code, which will hopefully make it easier to improve & maintain.
	

# 6. The future of the project

	In the nearest future, I'll continue with the application's code refactorization.
	At some point, I''ll consider making the application available on operation systems other than Windows.
	In the meantime, I'll try to address user comments regarding the manager.
	
	
# 7. Contact

	It is possible to contact me by:
	a) Email: grego.wh40k@gmail.com
	b) Reddit: u/Grego_from_Qinoth
	